-- HOLDS ALL GAME CONTROLS AND SOME FUNCTIONS RELATING TO THEM

-- interaction tables used by the menu system
pretable = {
	{x=0,y=0,w=800,h=600,action={"null"}},
	
	{x=310,y=140,w=24,h=24,action={"pre","res",-1},tip="Decrease resolution."},
	{x=344,y=140,w=24,h=24,action={"pre","res",1},tip="Increase resolution."},
	
	{x=120,y=164,w=24,h=24,action={"pre","full"},tip="Toggle fullscreen."},
	
	{x=45,y=202,w=15,h=147.5,action={"pre","colourslider",{1,1}},tip="Click to edit background red."},
	{x=85,y=202,w=15,h=147.5,action={"pre","colourslider",{1,2}},tip="Click to edit background green."},
	{x=125,y=202,w=15,h=147.5,action={"pre","colourslider",{1,3}},tip="Click to edit background blue."},
	{x=195,y=202,w=15,h=147.5,action={"pre","colourslider",{2,1}},tip="Click to edit foreground red."},
	{x=235,y=202,w=15,h=147.5,action={"pre","colourslider",{2,2}},tip="Click to edit foreground green."},
	{x=275,y=202,w=15,h=147.5,action={"pre","colourslider",{2,3}},tip="Click to edit foreground blue."},
	
	{x=5,y=413,w=370,h=20,action={"pre","presetcolours"},tip="set the colours to a preset."},
	
	{x=300,y=460,w=24,h=24,action={"pre","premenutoggle"},tip="Toggle this menu on startup."},
	
	{x=10,y=490,w=170,h=70,action={"pre","launch"},tip="Save settings and launch."},
}

loadtable = {
	{x=0,y=0,w=800,h=600,action={"null"}},
}

menutable = {
	{x=0,y=0,w=800,h=600,action={"null"}},
	
	{x=20,y=200,w=170,h=24,action={"main","challenges"},tip="Solve Puzzles."},
	{x=20,y=224,w=170,h=24,action={"main","sandbox"},tip="Create an Audio Tree."},
	{x=20,y=248,w=170,h=24,action={"main","options"},tip="Open the options."},
	{x=20,y=320,w=170,h=24,action={"main","quit"},tip="Exit the game."},
}

optionstable = {
	{x=0,y=0,w=800,h=600,action={"null"}},
	
	{x=20,y=176,w=155,h=24,action={"main","volumecontrol"},tip="Raise/Lower the master volume."},
	{x=20,y=200,w=155,h=24,action={"main","togglefullscreen"},tip="Fill/Reduce the amount of ATREE in your screenbox!"},
	{x=20,y=224,w=155,h=24,action={"main","premenutoggle"},tip="Toggle the premenu"},
	{x=20,y=248,w=155,h=24,action={"main","canvastoggle"},tip="Toggle use of canvases, not using them will run slower but it's an option if your system can't use canvas's. I.E if the sandbox synthmenu doesnt work."},
	{x=20,y=296,w=70,h=24,action={"main","return"},tip="Back to the main menu."},

}

sandboxtable = {
	{x=0,y=0,w=800,h=600,action={"null"}},
	
	{x=0,y=0,w=800,h=600,action={"game","canvas"}},
	{x=4,y=0,w=24,h=24,action={"hud","menu"},tip="Open a menu."},
	{x=36,y=0,w=24,h=24,action={"hud","changetool"},tip="Select a different tool, current = "..tool.."."},
	{x=64,y=0,w=24,h=24,action={"hud","synthmenu"},tip="Create a new synthesized sound."},
	{x=96,y=0,w=12,h=24,action={"hud","canvasdir",1}},
	{x=96,y=0,w=12,h=24,action={"hud","canvasdir",-1}},
	{x=110,y=0,w=0,h=24,action={"hud","canvas"}},
	{x=4,y=2,w=24,h=24,action={"hud","play/pause"}},
	{x=30,y=4,w=15,h=24,action={"hud","bpmchange",-1}},
	{x=46,y=4,w=15,h=24,action={"hud","bpmchange",-0.1}},
	{x=85,y=4,w=15,h=24,action={"hud","bpmchange",0.1}},
	{x=101,y=4,w=15,h=24,action={"hud","bpmchange",1}},
	{x=4,y=34,w=14,h=14,action={"hud","additionalpanel"}},
	{x=40,y=34,w=14,h=14,action={"hud","showbranchpos"}},
}

toolsradialtable = {
	{x=0,y=0,w=800,h=600,action={"hud","toolsradial","null"}},
	{x=0,y=0,w=125,h=60,action={"hud","toolsradial","branch"},tip="Branches: Draw with left mouse and delete with right."},
	{x=0,y=0,w=60,h=125,action={"hud","toolsradial","leaf"},tip="Leaves: Draw with left mouse and delete with right."},
	{x=0,y=0,w=60,h=60,action={"hud","toolsradial","+1"}},
	{x=0,y=0,w=60,h=125,action={"hud","toolsradial","pitch"},tip="Pitch: Adjust sounds, 1 with left or right mouse, 0.1 with mousewheel."},
	{x=0,y=0,w=125,h=60,action={"hud","toolsradial","volume"},tip="Volume: Adjust sounds, 1 with left or right mouse, 0.1 with mousewheel."},
}

sandboxmenutable = {
	{x=0,y=0,w=800,h=600,action={"null"}},
	
	{x=20,y=200,w=170,h=24,action={"main","continue"},tip="Minimise this menu."},
	{x=20,y=224,w=170,h=24,action={"main","load"},tip="Load a previous creation."},
	{x=20,y=248,w=170,h=24,action={"main","save"},tip="Save current state."},
	{x=20,y=272,w=170,h=24,action={"main","options"},tip="Open the options."},
	{x=20,y=296,w=170,h=24,action={"main","return"},tip="Return to the menu."},
	{x=20,y=320,w=170,h=24,action={"main","quit"},tip="Exit the game."},
}

synthmenutable = {
	{x=0,y=0,w=800,h=600,action={"null"}},
	
	{x=180,y=40,w=130,h=45,action={"synth","rename"}},
	{x=5,y=90,w=385,h=360,action={"synth","canvas"},tip="variablecanvasarea"},
	{x=380,y=90,w=10,h=20,action={"synth","canvasdir",1}},
	{x=380,y=430,w=10,h=20,action={"synth","canvasdir",-1}},
	{x=20,y=451,w=70,h=24,action={"synth","return"},tip="Return to the editor."},
	{x=150,y=451,w=75,h=24,action={"synth","preview"},tip="Preview your sound."},
	{x=300,y=451,w=75,h=24,action={"synth","create"},tip="Synthesize based on your settings."},
}

challengetable = {
	{x=0,y=0,w=800,h=600,action={"null"}},
}

-- currenttable to draw menu style interactions from
-- now in startup code
currenttable = currenttable

-- click area detection functions for menu code
function nearestMenu(x,y)
	current = nearestestui(x,y,currenttable)
	return current
end

function nearestestui(x,y,table)
	for i,v in ipairs(table) do
		if checkCollision(x,y,1,1,v.x,v.y,v.w,v.h) == true then
			id = i
		end
	end
	return id
end

--input library for mousepresses
function love.mousepressed(x,y,button)
	if button == "l" then
		if awolMouseCollider(x,y,2) ~= null then
			for i = 1,#windows do
				windows[i].z = 0
			end
			windows[awolMouseCollider(x,y,2)].z = 1
			table.sort(windows,awolSort)
		end
		if awolMouseCollider(x,y) ~= null then
			awolI.window = awolMouseCollider(x,y)
			awolI.pos = {windows[awolI.window].coords[1],windows[awolI.window].coords[2]}
			awolI.offset = {x-awolI.pos[1],y-awolI.pos[2]}
			if awolCollision(x,y,1,1,(awolI.pos[1]+windows[awolI.window].coords[3])-25,awolI.pos[2]-10,25,10) then
				if awolCollision(x,y,1,1,(awolI.pos[1]+windows[awolI.window].coords[3])-25,awolI.pos[2]-10,10,10) then
					if not windows[awolI.window].minimised then
						windows[awolI.window].minimised = true
					else
						windows[awolI.window].minimised = false
					end
				elseif awolCollision(x,y,1,1,(awolI.pos[1]+windows[awolI.window].coords[3])-10,awolI.pos[2]-10,10,10) then
					table.remove(windows,awolI.window)
				end
				awolI = {
					window = 0,
					pos = {},
					offset = {},
				}
			end
		elseif awolMouseCollider(x,y,1) ~= null then
			awolI.window = {awolMouseCollider(x,y,1)}
			awolI.pos = {windows[awolI.window[1]].coords[3],windows[awolI.window[1]].coords[4]}
			awolI.offset = {x-awolI.pos[1],y-awolI.pos[2]}
		end
		typedinput = false
		mouseAction(x,y,1)
	end
	if button == "r" then
		typedinput = false
		mouseAction(x,y,2)
	end
	if button == "wu" then
		mouseAction(x,y,3)
	end
	if button == "wd" then
		mouseAction(x,y,4)
	end
	if button == "m" then
		mouseAction(x,y,5)
	end
end

function love.mousereleased(x,y,button)
	if button == "m" then
		mouseAction(x,y,5)
	end
end

-- HUD DETECTION CODE


--SUPERFUNCTION
--controls all of the mouse actions within the editor
--a bit cryptic but not to hard to understand
function mouseAction(x,y,act)
	----MENU
	if area ~= "new_spritesheet2" and area ~= "edit_map" then
	
		--NULL INPUT
		--stops it from crashing if theres nothing at click
		if currenttable[nearestMenu(x,y)].action[1] == "null" then
			donothing = donothing
		
		--PRE-LOAD CONTROLS
		elseif currenttable[nearestMenu(x,y)].action[1] == "pre" then
			local n = nearestMenu(x,y)
			if currenttable[n].action[2] == "res" then
				if settings.currentres[3] + currenttable[n].action[3] <= #resolutions and settings.currentres[3] + currenttable[n].action[3] > 0 then
					settings.currentres[3] = settings.currentres[3] + currenttable[n].action[3]
				elseif settings.currentres[3] + currenttable[n].action[3] > #resolutions then
					settings.currentres[3] = 1
				elseif settings.currentres[3] + currenttable[n].action[3] < 1 then
					settings.currentres[3] = #resolutions
				end
				settings.currentres = {resolutions[settings.currentres[3] ].width,resolutions[settings.currentres[3] ].height,settings.currentres[3]}
			elseif currenttable[n].action[2] == "full" then
				if settings.fullscreen then
					settings.fullscreen = false
				else
					settings.fullscreen = true
				end
				
			elseif currenttable[n].action[2] == "colourslider" then
				if y > 212 and y < 339.5 then
					settings.colour[currenttable[n].action[3][1] ][currenttable[n].action[3][2] ] = (339.5 - y)*2
				elseif y < 212 then
					settings.colour[currenttable[n].action[3][1] ][currenttable[n].action[3][2] ] = 255
				elseif y > 339.5 then
					settings.colour[currenttable[n].action[3][1] ][currenttable[n].action[3][2] ] = 0
				end
					
			elseif currenttable[n].action[2] == "presetcolours" then
				local temp = x
				temp = temp - 5
				temp = temp / 25
				temp = roundtointeger(temp) + 1
				temp = colourpresets[temp]
				settings.colour = {{},{}}
				for i = 1,3 do
					table.insert(settings.colour[1],temp[1][i])
					table.insert(settings.colour[2],temp[2][i])
				end
				temp = nil
			
			elseif currenttable[n].action[2] == "premenutoggle" then
				if settings.premenu then
					settings.premenu = false
				else
					settings.premenu = true
				end
			elseif currenttable[n].action[2] == "launch" then
				area = "load"
				load = true
				currenttable = loadtable
				love.graphics.setMode( settings.currentres[1], settings.currentres[2], settings.fullscreen)
				love.filesystem.write("settings.lua","settings="..ropeBurn(settings))
				screenWidth, screenHeight = settings.currentres[1],settings.currentres[2]
				love.audio.setVolume( settings.volume )
				if settings.canvases then
					sounds.info.canvas = love.graphics.newCanvas(screenWidth,30)
					treecontrolrender()
				end
				area = "menu"
				currenttable = menutable
				currenttable[1].w,currenttable[1].h = screenWidth, screenHeight
				toolsradialtable[2].x,toolsradialtable[2].y = (screenWidth/2)-95, (screenHeight/2)-95
				toolsradialtable[3].x,toolsradialtable[3].y = (screenWidth/2)+35, (screenHeight/2)-95
				toolsradialtable[4].x,toolsradialtable[4].y = (screenWidth/2)-30, (screenHeight/2)-30
				toolsradialtable[5].x,toolsradialtable[5].y = (screenWidth/2)-95, (screenHeight/2)-30
				toolsradialtable[6].x,toolsradialtable[6].y = (screenWidth/2)-30, (screenHeight/2)+35
				load = false
				
			end
		elseif currenttable[nearestMenu(x,y)].action[1] == "main" then
			local n = nearestMenu(x,y)
			if currenttable[n].action[2] == "challenges" then
			
			elseif currenttable[n].action[2] == "sandbox" then
				area = "sandbox"
				menushow = false
				currenttable = sandboxtable
				currenttable[1].w,currenttable[1].h = screenWidth, screenHeight
				sliderinfo[1].b = -220
				
				-- a whole bunch of adjustments based on the current screenWidth
				currenttable[2].w, currenttable[2].h = screenWidth,screenHeight-30
				currenttable[3].y = screenHeight-26
				currenttable[4].y = screenHeight-26
				currenttable[5].y = screenHeight-26
				currenttable[6].y = screenHeight-26
				currenttable[7].y, currenttable[7].x = screenHeight-26, screenWidth-14
				currenttable[8].y, currenttable[8].w = screenHeight-26,screenWidth-128
				sandboxmenutable[1].w,sandboxmenutable[1].h = screenWidth, screenHeight
				if settings.canvases then
					treecontrolrender()
				end
				
			elseif currenttable[n].action[2] == "options" then
				currenttable = optionstable
				currenttable[1].w,currenttable[1].h = screenWidth, screenHeight
			elseif currenttable[n].action[2] == "quit" then
				love.filesystem.write("settings.lua","settings="..ropeBurn(settings))
				love.event.push('quit')
			elseif currenttable[n].action[2] == "volumecontrol" then
				if x >= 120 and x <= 135 then
					if settings.volume > 0.2 then
						settings.volume = settings.volume - 0.1
						love.audio.setVolume( settings.volume )
					elseif settings.volume > 0.1 then
						settings.volume = 0
					end
				elseif x >= 160 and x <= 175 then
					if settings.volume < 0.9 then
						settings.volume = settings.volume + 0.1
						love.audio.setVolume( settings.volume )
					end
				end
			elseif currenttable[n].action[2] == "togglefullscreen" then
				if settings.fullscreen then
					settings.fullscreen = false
				else
					settings.fullscreen = true
				end
				love.graphics.toggleFullscreen()
			elseif currenttable[n].action[2] == "premenutoggle" then
				if settings.premenu then
					settings.premenu = false
				else
					settings.premenu = true
				end
			elseif currenttable[n].action[2] == "canvastoggle" then
				if settings.canvases then
					settings.canvases = false
					sounds.info.canvas = nil
					synth.canvas = nil
				else
					settings.canvases = true
					sounds.info.canvas = love.graphics.newCanvas(screenWidth,30)
					treecontrolrender()
				end
			elseif currenttable[n].action[2] == "return" then
				if area == "menu" then
					currenttable = menutable
				elseif area == "sandbox" then
					if currenttable == optionstable then
						currenttable = sandboxmenutable
					elseif currenttable == sandboxmenutable then
						area = "menu"
						currenttable = menutable
					end
				end
			elseif currenttable[n].action[2] == "continue" then
				-- uses escape press to save major time on programming xD
				keyAction("escapepress")
			elseif currenttable[n].action[2] == "save" then
				-- empty until a later date
			end
		elseif currenttable[nearestMenu(x,y)].action[1] == "synth" then
			local n = nearestMenu(x,y)
			if act == 1 then
				if currenttable[n].action[2] == "canvas" then
					-- SUCH A LARGE CHUNK OF CODE THAT I PUT IT IN ANOTHER FUNCTION BELOW THIS SUPERFUNCTION
					synth.interact(x,y)
				elseif currenttable[n].action[2] == "canvasdir" then
					if synth.area == "s_stage1" then
						if currenttable[n].action[3] == -1 then
							synth.canvasy = synth.canvasy - (1*2)
							synthcontrolrender()
						elseif synth.canvasy < 0 then
							synth.canvasy = synth.canvasy + (1*2)
							synthcontrolrender()
						end
					elseif synth.area == "a_stage1" then
						if currenttable[n].action[3] == -1 then
							synth.canvasy = synth.canvasy - (1*2)
							audiocontrolrender()
						elseif synth.canvasy < 0 then
							synth.canvasy = synth.canvasy + (1*2)
							audiocontrolrender()
						end
					end
				
				elseif currenttable[n].action[2] == "rename" then
					if synth.area == "s_stage1" then
						synth.info.name = ""
						typed = {}
						typedinput = true
					elseif synth.area == "a_stage1" then
						if act == 1 then
							synth.info.name = ""
							typed = {}
							typedinput = true
						elseif act == 2 then
							synth.info.name = "BLOB" --synth.info.selected[2]
							audiocontrolrender()
						end
					end
				
				elseif currenttable[n].action[2] == "return" then
					if synth.area == "menu" then
						currenttable = sandboxtable
						menushow = false
						sliderinfo[1].b = -220
					else
						synth.area = "menu"
						synthmenutable[2].tip = nil
						synth.info = nil
						synth.canvasy = nil
						synth.canvastooltips = nil
						synth.canvas = nil
					end
				elseif currenttable[n].action[2] == "preview" then
					if synth.area == "s_stage1" then
						synth.preview =	synth.rendersound(synth.info)
						love.audio.stop(synth.preview)
						love.audio.play(synth.preview)
					elseif synth.area == "a_stage1" then
						if synth.info.selected[1] ~= 0 then
							local temp = sip.stringsplit(synth.info.selected[2],"%a+")
							if temp[#temp] == "mp3" or temp[#temp] == "ogg" or temp[#temp] == "wav" then
								local temp2 = "projects/AudioTree/samples"
								for i,v in ipairs(synth.info.filepath) do
									temp2 = temp2.."/"..v
								end
								temp2 = temp2.."/"..synth.info.selected[2]
								synth.preview = love.audio.newSource(temp2, "stream")
								love.audio.stop(synth.preview)
								love.audio.play(synth.preview)
								temp2 = nil
							end
							temp = nil
						end
					end
				elseif currenttable[n].action[2] == "create" then
					if synth.area == "s_stage1" then
						table.insert(sounds.data,{name=synth.info.name,sound=synth.rendersound(synth.info)})
						synth.info.name = "sound "..#sounds.data+1
						if settings.canvases then
							treecontrolrender()
						end
					elseif synth.area == "a_stage1" then
						if synth.info.selected[1] ~= 0 then
							local temp = sip.stringsplit(synth.info.selected[2],"%a+")
							if temp[#temp] == "mp3" or temp[#temp] == "ogg" or temp[#temp] == "wav" then
								local temp2 = "projects/AudioTree/samples"
								for i,v in ipairs(synth.info.filepath) do
									temp2 = temp2.."/"..v
								end
								temp2 = temp2.."/"..synth.info.selected[2]
								table.insert(sounds.data,{name=synth.info.name,sound=love.audio.newSource(temp2, "stream")})
								synth.info.name = "sound "..#sounds.data+1
								synth.info.selected = {0,""}
								if settings.canvases then
									treecontrolrender()
								end
								temp2 = nil
							end
						end
					end
				end
			elseif act == 3 or act == 4 then
				if currenttable[n].action[2] == "canvas" or currenttable[n].action[2] == "canvasdir" then
					if synth.area == "s_stage1" then
						if act == 3 then
							synth.canvasy = synth.canvasy - (1*5)
							synthcontrolrender()
						elseif act == 4 and synth.canvasy < 0 then
							synth.canvasy = synth.canvasy + (1*5)
							synthcontrolrender()
						end
					elseif synth.area == "a_stage1" then
						if act == 3 then
							synth.canvasy = synth.canvasy - (1*5)
							audiocontrolrender()
						elseif act == 4 and synth.canvasy < 0 then
							synth.canvasy = synth.canvasy + (1*5)
							audiocontrolrender()
						end
					end
				end
			end
		elseif currenttable[nearestMenu(x,y)].action[1] == "hud" then
			local n = nearestMenu(x,y)
			if currenttable[n].action[2] == "menu" then
				-- uses escape press to save major time on programming xD
				menushow = true
				keyAction("escapepress")
			elseif currenttable[n].action[2] == "synthmenu" then
				if sliderinfo[1].b == -220 then
					currenttable = synthmenutable
					synth.area = "menu"
					currenttable[1].w,currenttable[1].h = screenWidth, screenHeight
					sliderinfo[1].b = 200
					menuwidth = 400
				elseif sliderinfo[1].b == 0 then
					currenttable = sandboxtable
					sliderinfo[1].b = -220
				end
			elseif currenttable[n].action[2] == "changetool" then
				local I = whereintable(tool,tools)
				if I < #tools then
					I = I + 1
				elseif I >= #tools then
					I = 1
				end
				tool = tools[I]
				toolicon = toolsicon[I]
				currenttable[4].tip="Select a different tool, current = "..tool.."."
				tempbran = {}
				if settings.canvases then
					treecontrolrender()
				end
			elseif currenttable[n].action[2] == "toolsradial" then
				if currenttable[n].action[3] == "null" then
				
				elseif currenttable[n].action[3] == "branch" then
					tool = "branch"
					toolicon = "B"
					sandboxtable[4].tip="Select a different tool, current = "..tool.."."
					tempbran = {}
					if settings.canvases then
						treecontrolrender()
					end
				
				elseif currenttable[n].action[3] == "leaf" then
					tool = "leaf"
					toolicon = "L"
					sandboxtable[4].tip="Select a different tool, current = "..tool.."."
					tempbran = {}
					if settings.canvases then
						treecontrolrender()
					end
					
				elseif currenttable[n].action[3] == "+1" then
					local I = whereintable(tool,tools)
					if I == null then
						I = 1
					else
						if I < #tools then
							I = I + 1
						elseif I >= #tools then
							I = 1
						end
					end
					tool = tools[I]
					toolicon = toolsicon[I]
					sandboxtable[4].tip="Select a different tool, current = "..tool.."."
					tempbran = {}
					if settings.canvases then
						treecontrolrender()
					end
				
				elseif currenttable[n].action[3] == "pitch" then
					tool = "pitch"
					toolicon = "P"
					sandboxtable[4].tip="Select a different tool, current = "..tool.."."
					tempbran = {}
					if settings.canvases then
						treecontrolrender()
					end
				
				elseif currenttable[n].action[3] == "volume" then
					tool = "volume"
					toolicon = "V"
					sandboxtable[4].tip="Select a different tool, current = "..tool.."."
					tempbran = {}
					if settings.canvases then
						treecontrolrender()
					end
				
				end
				currenttable = sandboxtable
				
			elseif currenttable[n].action[2] == "canvasdir" and #sounds.data ~= 0 then
					if currenttable[n].action[3] == -1 then
						sounds.info.canvasx = sounds.info.canvasx - (1*2)
						treecontrolrender()
					elseif sounds.info.canvasx < 0 then
						sounds.info.canvasx = sounds.info.canvasx + (1*2)
						treecontrolrender()
					end
			elseif currenttable[n].action[2] == "canvas" and #sounds.data ~= 0 then
				local temp = 0
				for i = 1,#sounds.data do
					if x > 112+sounds.info.canvasx+(76*(i-1)) and x < 112+sounds.info.canvasx+(76*i) then
						temp = i
					end
				end
				if temp > 0 then
					sounds.data[temp].sound:setVolume(1)
					sounds.data[temp].sound:setPitch(1)
					love.audio.play(sounds.data[temp].sound)
					sounds.info.current = temp
					tool = "audio"
					toolicon = "A"
					tempbran = {}
					currenttable[4].tip="Select a different tool, current = "..tool.."."
					if settings.canvases then
						treecontrolrender()
					end
				end
				temp = nil
			elseif currenttable[n].action[2] == "bpmchange" then
				sounds.info.bpm = sounds.info.bpm + currenttable[n].action[3]
				if sounds.info.bpm <= 0 then
					sounds.info.bpm = 0.1
				end
			elseif currenttable[n].action[2] == "play/pause" then
				if playingaudio then
					playingaudio = false
				else
					playingaudio = true
					sounds.info.pos = 1
				end
			elseif currenttable[n].action[2] == "additionalpanel" then
				if sliderinfo[2].a <= 0 then
					sliderinfo[2].b = 100
					--tooltips to switch on
					currenttable[15].tip="show the branch heights."
				else
					sliderinfo[2].b = 0
					--tooltips to switch off
					currenttable[15].tip=nil
				end
			elseif currenttable[n].action[2] == "showbranchpos" then
				if settings.subsettings.showbranchpos then
					settings.subsettings.showbranchpos = false
				else
					settings.subsettings.showbranchpos = true
				end
			end
		elseif currenttable[nearestMenu(x,y)].action[1] == "game" then
			local n = nearestMenu(x,y)
			if currenttable[n].action[2] == "canvas" and not menushow then
				-- CONTROLS ALL TREE ACTIONS NON HUD RELATED
				if tool == "branch" then
					if act == 1 then
						if cle == 0 and #tempbran == 0 then
							tempbran = {screenWidth/2,screenHeight-28}
						elseif #branches > 0 or #tempbran > 0 then
							if #tempbran == 0 then
								tempbran = {branches[cle][3],branches[cle][4]}
							elseif #tempbran > 0 then
								local temp = false
								if tempbran[1] == x and tempbran[2] == y then
									temp = true
								end
								if temp == false then
									table.insert(branches,{tempbran[1],tempbran[2],x,y})
									table.insert(branchinfo,{size=0,pos=1,leaves = {}})
									for i = 1,#branches do
										branchinfo[i].size = descendancy(i)
									end
									heightset(1)
									tempbran = {}
								end
							end
						end
					elseif act == 2 then
						if #tempbran == 0 and descendancy(cle) == 0 then
							table.remove(branches,cle)
							table.remove(branchinfo,cle)
							for i = 1,#branches do
								branchinfo[i].size = descendancy(i)
							end
						elseif #tempbran > 0 then
							tempbran = {}
						end
					end
					
				elseif tool == "leaf" then
					if act == 1 then
						if cle ~= 0 then
							if #branches > 0 or #tempbran > 0 then
								if #tempbran == 0 then
									tempbran = {branches[cle][3],branches[cle][4],cle}
								elseif #tempbran > 0 then
									table.insert(branchinfo[tempbran[3]].leaves,{x,y,0,1,0}) -- posx,posy,sound,pitch,volume
									tempbran = {}
								end
							end
						end
					elseif act == 2 then
						if #tempbran == 0 then
							if cl[1] ~= 0 then
								if #branchinfo[cl[1]].leaves > 0 then
									table.remove(branchinfo[cl[1]].leaves,cl[2])
								end
							end
						elseif #tempbran > 0 then
							tempbran = {}
						end
					end
				
				elseif tool == "audio" then
					if cl[1] ~= 0 then
						if act == 1 then
							branchinfo[cl[1]].leaves[cl[2]][3] = sounds.info.current
						elseif act == 2 then
							branchinfo[cl[1]].leaves[cl[2]][3] = 0
						end
					end
				elseif tool == "pitch" then
					if cl[1] ~= 0 and cl[2] ~= 0 and branchinfo[cl[1]].leaves[cl[2]][3] ~= 0 then
						if act == 1 then
							branchinfo[cl[1]].leaves[cl[2]][4] = branchinfo[cl[1]].leaves[cl[2]][4] + 1
						elseif act == 2 then
							branchinfo[cl[1]].leaves[cl[2]][4] = branchinfo[cl[1]].leaves[cl[2]][4] - 1
						elseif act == 3 then
							branchinfo[cl[1]].leaves[cl[2]][4] = branchinfo[cl[1]].leaves[cl[2]][4] + 0.1
						elseif act == 4 then
							branchinfo[cl[1]].leaves[cl[2]][4] = branchinfo[cl[1]].leaves[cl[2]][4] - 0.1
						end
					end
				elseif tool == "volume" then
					if cl[1] ~= 0 and cl[2] ~= 0 and branchinfo[cl[1]].leaves[cl[2]][3] ~= 0 then
						if act == 1 then
							branchinfo[cl[1]].leaves[cl[2]][5] = branchinfo[cl[1]].leaves[cl[2]][5] + 1
						elseif act == 2 then
							branchinfo[cl[1]].leaves[cl[2]][5] = branchinfo[cl[1]].leaves[cl[2]][5] - 1
						elseif act == 3 then
							branchinfo[cl[1]].leaves[cl[2]][5] = branchinfo[cl[1]].leaves[cl[2]][5] + 0.1
						elseif act == 4 then
							branchinfo[cl[1]].leaves[cl[2]][5] = branchinfo[cl[1]].leaves[cl[2]][5] - 0.1
						end
					end
				end
				
				if act == 5 then
					love.mouse.setPosition( screenWidth/2, screenHeight/2 )
					currenttable = toolsradialtable
				end
			end
		end
	end
end

function synth.interact(x,y)
	if synth.area == "menu" then
		if x >= 20 and x <= 130 and y >= 150 and y <= 175 then
			--synthmenu
			synthmenutable[2].tip="Click to type a new name, just click again to deselect."
			synth.info = {name="",osc=1,octave=4,note="e",samplerate=44100,bits=16,len=1,effects={}}
			synth.info.name = "sound "..#sounds.data+1
			synth.area = "s_stage1"
			synth.canvasy = 0
			if settings.canvases then
				synth.canvas = love.graphics.newCanvas(386,360)
				-- DRAW TO CANVAS
				synthcontrolrender()
			end
		elseif x >= 20 and x <= 130 and y >= 200 and y <= 220 then
			--audiomenu
			synthmenutable[2].tip="Click to type a new name, just click again to deselect. Alternatively right click to just use the sound file name once you've selected one."
			synth.info = {name="",files={},filepath={},selected={0,""},textshow = false}
			synth.info.name = "sound "..#sounds.data+1
			synth.area = "a_stage1"
			synth.canvasy = 0
			synth.info.files = recursiveEnumerate("projects/AudioTree/samples")
			if settings.canvases then
				synth.canvas = love.graphics.newCanvas(386,360)
				-- DRAW TO CANVAS
				audiocontrolrender()
			end
		else
			--null
		end
	elseif synth.area == "s_stage1" then
		if x >= 7 and x <= 37 and y >= 110+synth.canvasy and y <= 140+synth.canvasy then
			--"Squarewave Oscillator."
			synth.info.osc = 1
		elseif x >= 42 and x <= 72 and y >= 110+synth.canvasy and y <= 140+synth.canvasy then
			--"Triangle Oscillator."
			synth.info.osc = 2
		elseif x >= 77 and x <= 107 and y >= 110+synth.canvasy and y <= 140+synth.canvasy then
			--"Sawtooth Oscillator."
			synth.info.osc = 3
		elseif x >= 112 and x <= 142 and y >= 110+synth.canvasy and y <= 140+synth.canvasy then
			--"Sinewave Oscillator."
			synth.info.osc = 4
		elseif x >= 147 and x <= 177 and y >= 110+synth.canvasy and y <= 140+synth.canvasy then
			--"White noise Oscillator."
			synth.info.osc = 5
		elseif x >= 182 and x <= 212 and y >= 110+synth.canvasy and y <= 140+synth.canvasy then
			--"Pink noise Oscillator."
			synth.info.osc = 6
		elseif x >= 217 and x <= 267 and y >= 110+synth.canvasy and y <= 140+synth.canvasy then
			--"Oscillators, the starting shape of the soundwave."
		elseif x >= 5 and x <= 115 and y >= 145+synth.canvasy and y <= 165+synth.canvasy then
			--"Note and pitch control, select the note on the keyboard and raise or lower the octave of the note with the arrows either side of the current octave number."
		elseif x >= 200 and x <= 215 and y >= 145+synth.canvasy and y <= 165+synth.canvasy then
			--"Lower the octave."
			if synth.info.octave > 1 then
				synth.info.octave = synth.info.octave - 1
			end
		elseif x >= 235 and x <= 250 and y >= 145+synth.canvasy and y <= 165+synth.canvasy then
			--"Raise the octave."
			if synth.info.octave < 10 then
				synth.info.octave = synth.info.octave + 1
			end
		elseif x >= 37.5 and x <= 87.5 and y >= 175+synth.canvasy and y <= 215+synth.canvasy then
			--"Select C#"
			synth.info.note = "c#"
		elseif x >= 92.5 and x <= 142.5 and y >= 175+synth.canvasy and y <= 215+synth.canvasy then
			--"Select D#"
			synth.info.note = "d#"
		elseif x >= 202.5 and x <= 252.5 and y >= 175+synth.canvasy and y <= 215+synth.canvasy then
			--"Select F#"
			synth.info.note = "f#"
		elseif x >= 257.5 and x <= 307.5 and y >= 175+synth.canvasy and y <= 215+synth.canvasy then
			--"Select G#"
			synth.info.note = "g#"
		elseif x >= 312.5 and x <= 362.5 and y >= 175+synth.canvasy and y <= 215+synth.canvasy then
			--"Select A#"
			synth.info.note = "a#"
		elseif x >= 10 and x <= 60 and y >= 175+synth.canvasy and y <= 240+synth.canvasy then
			--"Select C"
			synth.info.note = "c"
		elseif x >= 65 and x <= 115 and y >= 175+synth.canvasy and y <= 240+synth.canvasy then
			--"Select D"
			synth.info.note = "d"
		elseif x >= 120 and x <= 170 and y >= 175+synth.canvasy and y <= 240+synth.canvasy then
			--"Select E"
			synth.info.note = "e"
		elseif x >= 175 and x <= 225 and y >= 175+synth.canvasy and y <= 240+synth.canvasy then
			--"Select F"
			synth.info.note = "f"
		elseif x >= 230 and x <= 280 and y >= 175+synth.canvasy and y <= 240+synth.canvasy then
			--"Select G"
			synth.info.note = "g"
		elseif x >= 285 and x <= 335 and y >= 175+synth.canvasy and y <= 240+synth.canvasy then
			--"Select A"
			synth.info.note = "a"
		elseif x >= 340 and x <= 390 and y >= 175+synth.canvasy and y <= 240+synth.canvasy then
			--"Select B"
			synth.info.note = "b"
		elseif x >= 7 and x <= 37 and y >= 250+synth.canvasy and y <= 280+synth.canvasy then
			--"8 bit sound."
			synth.info.bits = 8
		elseif x >= 42 and x <= 72 and y >= 250+synth.canvasy and y <= 280+synth.canvasy then
			--"16 bit sound."
			synth.info.bits = 16
		elseif x >= 77 and x <= 107 and y >= 250+synth.canvasy and y <= 280+synth.canvasy then
			--"Control for the number of Bits."
		elseif x >= 180 and x <= 195 and y >= 250+synth.canvasy and y <= 280+synth.canvasy then
			--"Shorten the length."
			if synth.info.len > 1 then
				synth.info.len = synth.info.len - 1
				if synth.info.len < 0.1 then synth.info.len = 0.1 end
			end
		elseif x >= 196 and x <= 215 and y >= 250+synth.canvasy and y <= 280+synth.canvasy then
			--"Shorten the length."
			if synth.info.len > 0.1 then
				synth.info.len = synth.info.len - 0.1
				if synth.info.len < 0.1 then synth.info.len = 0.1 end
			end
		elseif x >= 240 and x <= 255 and y >= 250+synth.canvasy and y <= 280+synth.canvasy then
			--"Lengthen."
			synth.info.len = synth.info.len + 0.1
		elseif x >= 256 and x <= 270 and y >= 250+synth.canvasy and y <= 280+synth.canvasy then
			--"Lengthen."
			synth.info.len = synth.info.len + 1
		elseif x >= 250 and x <= 315 and y >= 250+synth.canvasy and y <= 280+synth.canvasy then
			--"Alter the length of the sample created with the 4 arrows."
		elseif x >= 5 and x <= 391 and y >= 290+synth.canvasy and y <= 290+synth.canvasy+(#synth.info.effects*100) then
			if #synth.info.effects > 0 then
				local temp,_ = math.modf((y - 290+synth.canvasy)/100)
				synth.effectinteract(x-5,y-(290+synth.canvasy+(100*temp)),temp+1)
				temp,_ = nil,nil
			end
		elseif x >= 295 and x <= 325 and y >= 290+synth.canvasy+(#synth.info.effects*100) and y <= 320+synth.canvasy+(#synth.info.effects*100) then
			--"Add an effect."
			local temp = true
			for i = 1,#synth.info.effects do
				if synth.info.effects[i].effect == "blank" then
					temp = false
				end
			end
			if temp then
				table.insert(synth.info.effects,{effect="blank"}) 
			end
			temp = nil
		end
		if settings.canvases then
			-- DRAW TO CANVAS
			synthcontrolrender()
		end
	elseif synth.area == "a_stage1" then
		if not synth.info.textshow then
			if #synth.info.filepath > 0 and x >= 5 and x <= 391 and y >= 90+synth.canvasy and y <= 120+synth.canvasy then -- 5,90
				synth.info.selected = {0,""}
				table.remove(synth.info.filepath)
				local temp = "projects/AudioTree/samples"
				for i,v in ipairs(synth.info.filepath) do
					temp = temp.."/"..v
				end
				synth.info.files = recursiveEnumerate(temp)
				temp = nil
				synth.canvasy = 0
			else
				x = x - 5
				local z = 0
				if #synth.info.filepath > 0 then
					z = 30
				end
				y = y - 90
				local temp,_ = math.modf(((y-z)-synth.canvasy)/30)+1
				if temp <= #synth.info.files and y>= 0 then
					synth.info.selected = {temp,synth.info.files[temp]}
				else
					synth.info.selected = {0,""}
				end
				temp = nil
				_ = nil
				z = nil
				if synth.info.selected[1] ~= 0 then
					local temp = sip.stringsplit(synth.info.selected[2],"[%.]")
					if #temp == 0 then
						table.insert(synth.info.filepath,synth.info.selected[2])
						local temp2 = "projects/AudioTree/samples"
						for i,v in ipairs(synth.info.filepath) do
							temp2 = temp2.."/"..v
						end
						synth.info.files = recursiveEnumerate(temp2)
						synth.info.selected = {0,""}
						synth.canvasy = 0
						temp2 = nil
					end
					temp = nil
					local temp = sip.stringsplit(synth.info.selected[2],"%a+")
					if #temp ~= 0 then
						if temp[#temp] == "txt" then
							synth.info.textshow = true
							synth.canvasy = 0
						end
					end
				end
			end
		else
			if x>355 and x<375 and y>91 and y<110 then
				synth.info.selected = {0,""}
				synth.canvasy = 0
				synth.info.textshow = false
			end
		end
		if settings.canvases then
			-- DRAW TO CANVAS
			audiocontrolrender()
		end
	end
end

function synth.effectinteract(x,y,pos)
	local name = synth.info.effects[pos].effect
	if name == "blank" then
	end
	name = nil
end

-- keypressed inputs
-- typed input toggles whether you are writing or using shortcuts
function love.keypressed(key,unicode)
	if key == "f2" then
		sip.power()
	elseif not sip.info.power then
		if not typedinput then
			if key == "f1" then
				keyAction("debug")
			end
			if key == "f3" then
				keyAction("nload")
			end
			if key == "escape" then
				keyAction("escapepress")
			end
		elseif typedinput then
			keyAction("typedinput",key)
		end
	else
		if shifton then
			sip.input(string.upper(key))
		else
			sip.input(key)
		end
	end
end

-- function that checks if a key is down every game tickyeah
shifton = null
function keydown()
	if love.keyboard.isDown("lshift") or love.keyboard.isDown("rshift") then
		shifton = true
	else
		shifton = false
	end
end

-- function that makes sure the key your pressing is an okay typedinput
function typedinputcheck(item)
	local temp = false
	local possibleinputs = {" ","1","2","3","4","5","6","7","8","9","0","q","w","e","r","t","y","u","i","o","p","a","s","d","f","g","h","j","k","l","z","x","c","v","b","n","m"}
	
	for i,v in ipairs(possibleinputs) do
		if item == v then
			temp = true
		end
	end
	
	return temp
end



--SUPERFUNCTION
--controls all of the actions from keyboard inputs from both
--keypressed and keydown
--x and y not just used for x and y positions
--but also for x and y arguments or information for ease of customisation of this table
function keyAction(action,x,y)
	if action == "debug" then
		if debug then
			debug = false
		else
			debug = true
		end
	elseif action == "nload" then
		local temp = {}
		for i,v in ipairs(lastmod[1]) do
			local temp2,_ = love.filesystem.getLastModified(v)
			table.insert(temp,temp2)
			temp2,_ = nil,nil
		end
		for i,v in ipairs(temp) do
			if v ~= lastmod[2][i] then
				ropeRead(lastmod[1][i])
			end
		end
		temp = nil
	elseif action == "fullscreen" then
		love.graphics.toggleFullscreen()
	elseif action == "escapepress" then
		if area == "menu" then
			love.event.push('quit')
		elseif area == "sandbox" then
			if sliderinfo[1].b == -220 then
				menushow = true
				currenttable = sandboxmenutable
				sliderinfo[1].b = 0
				menuwidth = 200
			elseif sliderinfo[1].b == 0 then
				menushow = false
				currenttable = sandboxtable
				sliderinfo[1].b = -220
			end
		end
	elseif action == "camera_keydir" then
		keydir = {x,y}
	elseif action == "typedinput" then
		local target = "null"
		if currenttable == synthmenutable then
			if x == "backspace" or x == "delete" then
				table.remove(typed)
				synth.info.name = table.concat(typed)
			else
				if font24:getWidth(table.concat(typed)) <= 185 and typedinputcheck(x) then
					if shifton then
						table.insert(typed,string.upper(x))
					else
						table.insert(typed,x)
					end
					synth.info.name = table.concat(typed)
				end
			end
		end
	elseif action == "ctt" then
		if x then
			local increase = 0
			if ctt[2] + 1 <= #tiletypes then
				increase = ctt[2] + 1
			elseif ctt[2] + 1 > #tiletypes then
				increase = 1
			end
			ctt = {tiletypes[increase][1],increase}
		elseif not x then
			local decrease = 0
			if ctt[2] - 1 > 0 then
				decrease = ctt[2] - 1
			elseif ctt[2] - 1 < 1 then
				decrease = #tiletypes
			end
			ctt = {tiletypes[decrease][1],decrease}
		end
		if area == "edit_map" then
			menu = {sheet = {},quad = {},scale = {}}
			for i = 1,3 do
				menu.sheet[i], menu.quad[i] = getmenudata(i-2)
				local foo, foo, foo, scale = menu.quad[i]:getViewport()
				menu.scale[i] = 100 / scale
			end
		end
	elseif action == "ctp" then
		local test = null
		if ctt[1] == "tile" then
			test = #spritesheets.quadInfo
		elseif ctt[1] == "overlay" then
			test = #spritesheets.overlayquadInfo
		elseif ctt[1] == "object" then
			test = #spritesheets.objectquadInfo
		end
		assert(test ~= null,"TEST == NULL (control.lua(548))")
		if x then
			local increase = 0
			if ctp[ctt[2]] + 1 <= test then
				increase = ctp[ctt[2]] + 1
			elseif ctp[ctt[2]] + 1 > test then
				increase = 1
			end
			ctp[ctt[2]] = increase
		elseif not x then
			local decrease = 0
			if ctp[2] - 1 > 0 then
				decrease = ctp[ctt[2]] - 1
			elseif ctp[2] - 1 < 1 then
				decrease = test
			end
			ctp[ctt[2]] = decrease
		end
		
		menu = {sheet = {},quad = {},scale = {}}
		for i = 1,3 do
			menu.sheet[i], menu.quad[i] = getmenudata(i-2)
			local foo, foo, foo, scale = menu.quad[i]:getViewport()
			menu.scale[i] = 100 / scale
		end
		
	elseif action == "tilesize" then
		tilesize = tilesize + x
	elseif action == "backgroundshade" then
		if backgroundshade >= 255 then
			backgroundshade = 254
		elseif backgroundshade <= 0 then
			backgroundshade = 1
		elseif backgroundshade <= 255 and backgroundshade >= 0 then
			backgroundshade = backgroundshade + x
		end
	elseif action == "map_save" then
		mapsave()
	end
end










