--SUPERFUNCTION
--handles all of the display information for the different "area"'s of the code
--really simple to use
--easy to understand
function display ()
	love.graphics.setFont(font24)
	love.graphics.setLine( 1, "rough" )
	--load area
	if area == "load" then
		if load then
			love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3])
			love.graphics.polygon("fill",screenWidth-125,5,screenWidth-5,5,screenWidth-5,39,screenWidth-115,39,screenWidth-125,29)
			love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
			love.graphics.print("...LOADING...",screenWidth-120,10)
		end
	end

	--pre area
	if area == "pre-menu" then
		-- design
		love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3])
		love.graphics.polygon("fill",0,0,400,0,400,30,200,30,180,90,0,90)
		love.graphics.polygon("fill",180,570,200,490,400,490,400,600,0,600,0,570)
		love.graphics.polygon("fill",10,560,170,560,186,490,10,490)
		
		love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3],180)
		love.graphics.polygon("line",0,0,400,0,400,30,200,30,180,90,0,90)
		love.graphics.polygon("line",180,570,200,490,400,490,400,600,0,600,0,570)
		love.graphics.polygon("line",10,560,170,560,186,490,10,490)
		
		--titles
		love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3],255)
		love.graphics.setFont(font48)
		love.graphics.print("A.Tree",210,50)
		love.graphics.setFont(font24)
		love.graphics.print("Audio Arborials.",230,90)
		
		--options
		love.graphics.print("Screen Resolution: "..resolutions[settings.currentres[3] ].width.." x "..resolutions[settings.currentres[3] ].height,10,140)
		love.graphics.rectangle("line",310,140,24,24)
		love.graphics.rectangle("line",344,140,24,24)
		love.graphics.print("-   +",315,140)
		
		love.graphics.print("Fullscreen:",10,164)
		love.graphics.rectangle("line",120,164,24,24)
		if settings.fullscreen then
			love.graphics.print("X",125,168)
		end
		--colourcontrol
		love.graphics.print("Colors:",10,188)
		love.graphics.print("1:",20,212)
		love.graphics.rectangle("fill",50,212,5,127.5)
		love.graphics.rectangle("fill",45,339.5-(settings.colour[1][1]/2),15,10)
		love.graphics.print(settings.colour[1][1],45,360)
		
		love.graphics.rectangle("fill",90,212,5,127.5)
		love.graphics.rectangle("fill",85,339.5-(settings.colour[1][2]/2),15,10)
		love.graphics.print(settings.colour[1][2],85,360)
		
		love.graphics.rectangle("fill",130,212,5,127.5)
		love.graphics.rectangle("fill",125,339.5-(settings.colour[1][3]/2),15,10)
		love.graphics.print(settings.colour[1][3],125,360)
		
		love.graphics.print("2:",170,212)
		love.graphics.rectangle("fill",200,212,5,127.5)
		love.graphics.rectangle("fill",195,339.5-(settings.colour[2][1]/2),15,10)
		love.graphics.print(settings.colour[2][1],195,360)
		
		love.graphics.rectangle("fill",240,212,5,127.5)
		love.graphics.rectangle("fill",235,339.5-(settings.colour[2][2]/2),15,10)
		love.graphics.print(settings.colour[2][2],235,360)
		
		love.graphics.rectangle("fill",280,212,5,127.5)
		love.graphics.rectangle("fill",275,339.5-(settings.colour[2][3]/2),15,10)
		love.graphics.print(settings.colour[2][3],275,360)
		
		-- simple menu option to not show this menu
		love.graphics.print("Always show this on startup:",10,460)
		love.graphics.rectangle("line",300,460,24,24)
		if settings.premenu then
			love.graphics.print("X",305,464)
		end

		--colour preset panel
		love.graphics.print("Presets:",5,384)
		for i = 1,#colourpresets do
			love.graphics.setColor(colourpresets[i][1][1],colourpresets[i][1][2],colourpresets[i][1][3])
			love.graphics.rectangle("fill",5+(25*(i-1)),413,20,20)
			love.graphics.setColor(colourpresets[i][2][1],colourpresets[i][2][2],colourpresets[i][2][3])
			love.graphics.line(5+(25*(i-1)),413,25+(25*(i-1)),433)
			love.graphics.line(25+(25*(i-1)),413,5+(25*(i-1)),433)
		end
		love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3])
		for i = 1,15 do
			love.graphics.rectangle("line",5+(25*(i-1)),413,20,20)
		end
		
		-- logos and launch
		love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
		love.graphics.draw(obscurelogo,5,5,0,2.2)
		love.graphics.print("Presenting",200,0)
		love.graphics.print("Launch A.Tree",20,500)
		love.graphics.setFont(debugfont)
		love.graphics.print("Version: "..version,20,540)
		love.graphics.setFont(font24)
		love.graphics.print("Created on",205,490)
		love.graphics.draw(lovelogo,195,495,0,0.8)
	end
	
	-- main menu.
	if area == "menu" then
		drawTree()
		love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3],180)
		love.graphics.rectangle("fill",200,0,10,screenHeight)
		love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3],255)
		love.graphics.rectangle("fill",0,0,200,screenHeight)
		love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
		love.graphics.setFont(font48)
		love.graphics.print("A.Tree",10,20)
		love.graphics.setFont(font24)
		love.graphics.print("Audio Arborials.",10,70)
		
		if currenttable == menutable then
			love.graphics.print("Challenges",20,200)
			love.graphics.print("Sandbox",20,224)
			love.graphics.print("Options",20,248)
			love.graphics.print("Quit",20,320)
		elseif currenttable == optionstable then
			love.graphics.print("Volume:",20,176)
			love.graphics.print("<    >",125,176)
			love.graphics.print(settings.volume,135,176)
			
			love.graphics.print("Fullscreen:",20,200)
			love.graphics.rectangle("line",150,200,24,24)
			if settings.fullscreen then
				love.graphics.print("X",155,200)
			end
			love.graphics.print("Premenu:",20,224)
			love.graphics.rectangle("line",150,224,24,24)
			if settings.premenu then
				love.graphics.print("X",155,224)
			end
			love.graphics.print("Canvases:",20,248)
			love.graphics.rectangle("line",150,248,24,24)
			if settings.canvases then
				love.graphics.print("X",155,248)
			end
			love.graphics.print("Return",20,296)
		end
	end
	
	--sandbox area
	if area == "sandbox" then
		drawTree()
		if sliderinfo[1].a > -210 then
			love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3],180)
			love.graphics.rectangle("fill",sliderinfo[1].a+200,0,10,screenHeight)
			love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3],255)
			love.graphics.rectangle("fill",sliderinfo[1].a-(menuwidth-200),0,menuwidth,screenHeight)
			love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3],255)
			if not settings.canvases and currenttable == synthmenutable and synth.area == "s_stage1" then
				synthcontrolrender()
				love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3])
				love.graphics.rectangle("fill",0,0,menuwidth,90)
				love.graphics.rectangle("fill",0,451,menuwidth,screenHeight-451)
				love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
			elseif not settings.canvases and currenttable == synthmenutable and synth.area == "a_stage1" then
				audiocontrolrender()
				love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3])
				love.graphics.rectangle("fill",0,0,menuwidth,90)
				love.graphics.rectangle("fill",0,451,menuwidth,screenHeight-451)
				love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
			end
			love.graphics.setFont(font48)
			love.graphics.print("A.Tree",sliderinfo[1].a+10-(menuwidth-200),20)
			love.graphics.setFont(font24)
			love.graphics.print("Audio Arborials.",sliderinfo[1].a+10-(menuwidth-200),70)
			if currenttable ~= synthmenutable and menushow then
				if currenttable == sandboxmenutable or currenttable == sandboxtable then
					love.graphics.print("Continue",sliderinfo[1].a+20,200)
					love.graphics.print("Load",sliderinfo[1].a+20,224)
					love.graphics.print("Save",sliderinfo[1].a+20,248)
					love.graphics.print("Options",sliderinfo[1].a+20,272)
					love.graphics.print("Menu Return",sliderinfo[1].a+20,296)
					love.graphics.print("Quit",sliderinfo[1].a+20,320)
				elseif currenttable == optionstable then
					love.graphics.print("Volume:",20,176)
					love.graphics.print("<    >",125,176)
					love.graphics.print(settings.volume,135,176)
					
					love.graphics.print("Fullscreen:",20,200)
					love.graphics.rectangle("line",150,200,24,24)
					if settings.fullscreen then
						love.graphics.print("X",155,200)
					end
					love.graphics.print("Premenu:",20,224)
					love.graphics.rectangle("line",150,224,24,24)
					if settings.premenu then
						love.graphics.print("X",155,224)
					end
					love.graphics.print("Canvases:",20,248)
					love.graphics.rectangle("line",150,248,24,24)
					if settings.canvases then
						love.graphics.print("X",155,248)
					end
					love.graphics.print("Return",20,296)
				end
			else
				--love.graphics.print("SYNTH",sliderinfo[1].a+250-(menuwidth-200),40)
				--love.graphics.print("-controls-",sliderinfo[1].a+230-(menuwidth-200),64)
				
				-- VARIABLE DISPLAYS
				if synth.area == "menu" then
					love.graphics.print("New Synth.",sliderinfo[1].a+20-(menuwidth-200),150)
					love.graphics.print("New Sound.",sliderinfo[1].a+20-(menuwidth-200),200)
					love.graphics.print("Return.",sliderinfo[1].a+20-(menuwidth-200),451)
				elseif synth.area == "s_stage1" then
					love.graphics.print("SYNTHNAME",sliderinfo[1].a+180-(menuwidth-200),40)
					love.graphics.print("- "..synth.info.name.." -",sliderinfo[1].a+180-(menuwidth-200),64)
					if settings.canvases then
						love.graphics.setColor(255,255,255,255)
						love.graphics.draw(synth.canvas,5,90)
						love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
					end
				elseif synth.area == "a_stage1" then
					love.graphics.print("AUDIONAME",sliderinfo[1].a+180-(menuwidth-200),40)
					love.graphics.print("- "..synth.info.name.." -",sliderinfo[1].a+180-(menuwidth-200),64)
					if settings.canvases then
						love.graphics.setColor(255,255,255,255)
						love.graphics.draw(synth.canvas,5,90)
						love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
					end
				end
				--
				
				love.graphics.print("Return.",sliderinfo[1].a+20-(menuwidth-200),451)
				
				if synth.area == "s_stage1" then
					love.graphics.print("Preview.",sliderinfo[1].a+150-(menuwidth-200),451)
					love.graphics.print("Create.",sliderinfo[1].a+300-(menuwidth-200),451)
				elseif synth.area == "a_stage1" then
					if synth.info.selected[1] ~= 0 then
						local temp = sip.stringsplit(synth.info.selected[2],"%a+")
						if temp[#temp] == "mp3" or temp[#temp] == "ogg" or temp[#temp] == "wav" then
							love.graphics.print("Preview.",sliderinfo[1].a+150-(menuwidth-200),451)
							love.graphics.print("Create.",sliderinfo[1].a+300-(menuwidth-200),451)
						end
					end
				end
			end
		end	
	end
	
	-- load menu, not often seen unless synths are rendering slowly
	if load then
		
		love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3])
		love.graphics.polygon("fill",screenWidth-125,5,screenWidth-5,5,screenWidth-5,39,screenWidth-115,39,screenWidth-125,29)
		love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
		love.graphics.print("...LOADING...",screenWidth-120,10)
	end
end

--EVERYTHING PERTAINING TO THE SYNTHESIZER PANELS VISUAL APPEARANCE
	--the table containing the shapes of the waves
local wavelines = {
	{0,15,5,15,5,5,15,5,15,25,25,25,25,15,30,15},
	{0,15,5,15,10,5,15,15,20,25,25,15,30,15},
	{0,15,5,15,5,5,15,25,15,5,25,25,25,15,30,15},
	{0,15,5,15,6,13,7,11,7.5,9,9,6,10,5,11,6,12.5,9,13,11,14,13,15,15,16,17,17,19,17.5,21,19,24,20,25,21,24,22.5,21,23,19,24,17,25,15,30,15},
	{0,15,5,15,9,6,13,23,17,5,21,19,24,7,25,15,30,15},
	{0,15,5,15,5,20,9,15,13,17,17,11,21,15,23,10,25,15,30,15},
}
	--the table containing the names of the notes
local notenames = {
	{"c","d","e","f","g","a","b"},
	{"c#","d#"," ","f#","g#","a#"},
}
	
	--THE FUNCTIONS THAT RENDERS THE CONTROL PANELS TO THE CANVAS
function synthcontrolrender()
	local x = 0
	local y = 0
	if settings.canvases then
		synth.canvas:clear()
		love.graphics.setCanvas(synth.canvas)
	else
		x = 5
		y = 90
	end

	love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
	love.graphics.setFont(font24)
	--INPUT OSC's
	local pos = 0
	for i = 1,6 do
		local temp = 0
		local templine = {}
		for j = 1,#wavelines[i] do
			table.insert(templine,wavelines[i][j])
		end
		
		if i > 6 then
			temp, null = math.modf(i/11)
		end
		
		for j,w in ipairs(templine) do
			if math.mod(j,2) == 0 then
				templine[j] = wavelines[i][j] + (20+(temp*35)+synth.canvasy+y)
			else
				templine[j] = wavelines[i][j] + (5+(35*(i-1))+x) 
			end
		end
		
		love.graphics.line(templine)
		love.graphics.rectangle("line",5+(35*(i-1))+x,20+(temp*35)+synth.canvasy+y,30,30)
		pos = {5+(35*(i-1)),20+(temp*35)}
		love.graphics.setLine(4,"rough")
		love.graphics.rectangle("line",5+(35*(synth.info.osc-1))+x,20+(temp*35)+synth.canvasy+y,30,30)
		love.graphics.setLine(1,"rough")
		temp = nil
	end
	if (pos[1]+35) + font24:getWidth("OSC's") < 385 then
		love.graphics.print("OSCs",pos[1]+35+x,pos[2]+synth.canvasy+y+4)
		pos = {pos[1]+35,pos[2]}
	else
		love.graphics.print("OSCs.",5+x,pos[2]+35+synth.canvasy+y+4)
		pos = {5,pos[2]+35}
	end	
	--NOTE AND OCTAVE CONTROL
	love.graphics.print("Note/Pitch.",5+x,pos[2]+35+synth.canvasy+y+4)
	pos = {5,pos[2]+35}
	love.graphics.print("< "..synth.info.octave.." >",200+x,pos[2]+synth.canvasy+y)
	for i = 1,7 do
		love.graphics.rectangle("line",5+(55*(i-1))+x,pos[2]+30+synth.canvasy+y,50,65)
		love.graphics.print(notenames[1][i],25+(55*(i-1))+x,pos[2]+65+synth.canvasy+y+4)
	end
	if whereintable(synth.info.note,notenames[1]) ~= null then
		love.graphics.setLine(4,"rough")
		love.graphics.rectangle("line",5+(55*(whereintable(synth.info.note,notenames[1])-1))+x,pos[2]+30+synth.canvasy+y,50,65)
		love.graphics.setLine(1,"rough")
	end
	for i = 1,6 do
		if i ~= 3 then
			love.graphics.rectangle("fill",32.5+(55*(i-1))+x,pos[2]+29+synth.canvasy+y,50,40)
			love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3])
			love.graphics.print(notenames[2][i],44+(55*(i-1))+x,pos[2]+35+synth.canvasy+y)
			love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3],255)
		end
	end
	if whereintable(synth.info.note,notenames[2]) ~= null then
		love.graphics.rectangle("line",(32.5+(55*(whereintable(synth.info.note,notenames[2])-1)))-2+x,(pos[2]+29+synth.canvasy)-2+y,54,44)
	end
	pos = {5,pos[2]+105}
	-- BIT AND LENGTH SELECTION
	for i = 1,2 do
		love.graphics.rectangle("line",pos[1]+(35*(i-1))+x,pos[2]+synth.canvasy+y,30,30)
		love.graphics.print(i*8,pos[1]+5+(35*(i-1))+x,pos[2]+synth.canvasy+y+4)
	end
	love.graphics.setLine(4,"rough")
	love.graphics.rectangle("line",pos[1]+35*((synth.info.bits/8)-1)+x,pos[2]+synth.canvasy+y,30,30)
	love.graphics.setLine(1,"rough")
	
	love.graphics.print(synth.info.len,210+x,pos[2]+synth.canvasy+y)
	love.graphics.print("< <    > > LENGTH",180+x,pos[2]+synth.canvasy+y)
	
	pos = {pos[1]+(35*2),pos[2]}
	love.graphics.print("BITs",pos[1]+x,pos[2]+synth.canvasy+y+4)
	pos = {5,pos[2]+40}
	--LENGTH SELECTION
	
	--TRULY VARIABLE CONTENT
	for i = 1,#synth.info.effects do
		local temp = 0+(100*(i-1))
		if synth.info.effects[i].effect == "blank" then
			for i,v in ipairs(effectsinfo) do
				love.graphics.print(v[1],pos[1],pos[2]+synth.canvasy+y)
				if pos[1] == 5 then
					pos[1] = pos[1] + 195
				else
					pos[1] = 5
					pos[2] = pos[2] + 30
				end
			end
		end
		temp = nil
	end
	
	--TRULY VARIABLE CONTENT ADDITION MENU
	love.graphics.line(35+x,pos[2]+synth.canvasy+y+(#synth.info.effects*100),320+x,pos[2]+synth.canvasy+y+(#synth.info.effects*100))
	love.graphics.rectangle("line",290+x,pos[2]+synth.canvasy+y+(#synth.info.effects*100),30,30)
	love.graphics.print("Add Effect/Filter.  X",118+x,pos[2]+synth.canvasy+y+4+(#synth.info.effects*100))
	
	-- SLIDERS
	love.graphics.rectangle("line",375+x,1+y,10,20)
	love.graphics.line(376+x,10+y,380+x,2+y,384+x,10+y)
	love.graphics.rectangle("line",375+x,340+y,10,20)
	love.graphics.line(376+x,350+y,380+x,358+y,384+x,350+y)
	
	if settings.canvases then
		love.graphics.setCanvas()
	end
end

function audiocontrolrender()
	local x = 0
	local y = 0
	if settings.canvases then
		synth.canvas:clear()
		love.graphics.setCanvas(synth.canvas)
	else
		x = 5
		y = 90
	end

	love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
	love.graphics.setFont(font24)
	
	-- FILES
	for i,v in ipairs(synth.info.files) do
		local z = 0
		if #synth.info.filepath > 0 then
			z = 30
		end
		if synth.info.selected[1] == i then
			love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
			love.graphics.rectangle("fill",0+x,z+y+synth.canvasy+(30*(i-1)),386,30)
			love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3])
		else
			love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
		end
		local temp = sip.stringsplit(v,"[%.]")
		if #temp == 0 then
			love.graphics.triangle("fill",5+x,z+19+y+synth.canvasy+(30*(i-1)),12.5+x,z+4+y+synth.canvasy+(30*(i-1)),20+x,z+19+y+synth.canvasy+(30*(i-1)))
		else
			love.graphics.rectangle("fill",5+x,z+4+y+synth.canvasy+(30*(i-1)),15,15)
		end
		love.graphics.print(v,25+x,z+y+synth.canvasy+(30*(i-1))+4)
		temp = nil
	end
	
	-- RETURN
	if #synth.info.filepath > 0 then
		love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
		love.graphics.triangle("fill",5+x,4+y+synth.canvasy,12.5+x,19+y+synth.canvasy,20+x,4+y+synth.canvasy)
		love.graphics.print("...",25+x,y+synth.canvasy)
	end
	
	if synth.info.textshow then
		local temp = "samples"
		local lines = ""
		for i,v in ipairs(synth.info.filepath) do
			temp = temp.."/"..v
		end
		temp = temp.."/"..synth.info.selected[2]
		for line in love.filesystem.lines(temp) do
			lines = lines.."\n"..line
		end
		love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3])
		love.graphics.rectangle("fill",0+x,0+y,386,360)
		love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
		love.graphics.print(synth.info.selected[2],25+x,y+synth.canvasy)
		love.graphics.printf(lines,x,30+y+synth.canvasy,340,"left")
		love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3])
		love.graphics.rectangle("fill",x+355,y+1,20,20)
		love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
		love.graphics.rectangle("line",x+355,y+1,20,20)
		love.graphics.print("X",x+360,y+2)
		temp = nil
		lines = nil
	end
	
	-- SLIDERS
	love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3])
	love.graphics.rectangle("fill",375+x,1+y,10,20)
	love.graphics.rectangle("fill",375+x,340+y,10,20)
	love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
	love.graphics.rectangle("line",375+x,1+y,10,20)
	love.graphics.line(376+x,10+y,380+x,2+y,384+x,10+y)
	love.graphics.rectangle("line",375+x,340+y,10,20)
	love.graphics.line(376+x,350+y,380+x,358+y,384+x,350+y)
	
	if settings.canvases then
		love.graphics.setCanvas()
	end
end

	--THE FUNCTION THAT RENDERS THE CONTROLS ON THE MAIN GAME PAGE
function treecontrolrender()
	local y = 0
	if settings.canvases then
		sounds.info.canvas:clear()
		love.graphics.setCanvas(sounds.info.canvas)
	else
		y = screenHeight - 30
	end
	local pos = 112
	
	--important stuff that can run with canvases or without
	love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3])
	love.graphics.setFont(font24)
	
	love.graphics.rectangle("fill",0,y,screenWidth,30)
	
	love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
	if sounds.info.current ~= 0 then
		love.graphics.rectangle("fill",pos+sounds.info.canvasx+(77*(sounds.info.current-1)),y+4,75,24)
	end
	love.graphics.setFont(font14)
	for i = 1,#sounds.data do
		if i == sounds.info.current then
			love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3])
		else
			love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
		end
		love.graphics.rectangle("line",pos+sounds.info.canvasx,y+4,75,24)
		if font14:getWidth(sounds.data[i].name) < 68 then
			love.graphics.print(i..":"..sounds.data[i].name,pos+2+sounds.info.canvasx,y+4)
		else
			local temp = 0
			temp = stringsplit(sounds.data[i].name)
			repeat
				table.remove(temp)
			until font14:getWidth(table.concat(temp)) < 68
			temp = table.concat(temp)
			love.graphics.print(i..":"..temp,pos+2+sounds.info.canvasx,y+4)
			temp = nil
		end
		pos = pos + 77
	end
	love.graphics.setFont(font24)
	
	love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3])
	love.graphics.rectangle("fill",0,y,110,30)
	love.graphics.rectangle("fill",screenWidth-18,y,18,30)
	love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
	
	love.graphics.rectangle("line",96,y+4,12,24)
	love.graphics.print("<",97,y+6)
	love.graphics.rectangle("line",screenWidth-14,y+4,12,24)
	love.graphics.print(">",screenWidth-12,y+6)
	
	love.graphics.rectangle("line",4,y+4,24,24)
	love.graphics.print("M",8,y+8)
	
	love.graphics.line(32,y+4,32,y+28)
	
	love.graphics.rectangle("line",36,y+4,24,24)
	love.graphics.print(toolicon,40,y+8)
	
	if area == "sandbox" then
		love.graphics.rectangle("line",64,y+4,24,24)
		love.graphics.print("S",68,y+8)
		love.graphics.line(92,y+4,92,y+28)
	else
		love.graphics.line(92,y+4,92,y+28)
	end
	
	if settings.canvases then
		love.graphics.setCanvas()
	end
end

-- RENDERING THE TREES.
function drawTree()
	
	love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3])
	love.graphics.setFont(font14)
	love.graphics.polygon("fill",screenWidth/2-20,screenHeight-30,screenWidth/2,screenHeight-50,screenWidth/2+20,screenHeight-30)
	if settings.canvases then
		love.graphics.setColor(255,255,255,255)
		love.graphics.draw(sounds.info.canvas,0,screenHeight-30)
	else
		treecontrolrender()
	end
	
	love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3],255)
	for i,v in ipairs(branches) do
		love.graphics.setLine( 2 + (branchinfo[i].size/2), "smooth" )
		love.graphics.line(v)
		if settings.subsettings.showbranchpos then
			love.graphics.setLine(1,"rough")
			love.graphics.rectangle("line",v[3]+7,v[4]-1,14,14)
			love.graphics.print(branchinfo[i].pos,v[3]+10,v[4])
		end
	end
	if #tempbran > 0 then
		love.graphics.line(tempbran[1],tempbran[2],mX,mY)
		if tool == "leaf" then
			if mX > tempbran[1] then
				love.graphics.polygon("fill",mX,mY,mX+20,mY+10,mX+15,mY+15,mX-5,mY+5)
			else
				love.graphics.polygon("fill",mX,mY,mX+5,mY+5,mX-15,mY+15,mX-20,mY+10)
			end
		end
	end
	for i,v in ipairs(branchinfo) do
		love.graphics.setLine(1,"smooth")
		for j,w in ipairs(v.leaves) do
			love.graphics.line(branches[i][3],branches[i][4],w[1],w[2])
			if w[1] > branches[i][3] then
				love.graphics.polygon("fill",w[1],w[2],w[1]+20,w[2]+10,w[1]+15,w[2]+15,w[1]-5,w[2]+5)
			else
				love.graphics.polygon("fill",w[1],w[2],w[1]+5,w[2]+5,w[1]-15,w[2]+15,w[1]-20,w[2]+10)
			end
			if w[3] ~= 0 then
				if tool == "volume" then
					love.graphics.print(w[3].."."..w[5],w[1],w[2]+5)
				elseif tool == "pitch" then
					love.graphics.print(w[3].."."..w[4],w[1],w[2]+5)
				else
					love.graphics.print(w[3],w[1],w[2]+5)
				end
			end
		end
	end
	love.graphics.setLine( 1, "rough" )
	if cle ~= 0 and tool ~= "audio" then
		if tick > 1 then
			love.graphics.rectangle("line",branches[cle][3]-10,branches[cle][4]-10,20,20)
		end
	else
		if area ~= "menu" then
			if tick > 1 then
				love.graphics.rectangle("line",screenWidth/2-10,screenHeight-60,20,20)
			end
		end
	end
	if cl[1] ~= 0 then
		if tick <= 1 then
			love.graphics.circle("line",branchinfo[ cl[1] ].leaves[ cl[2] ][1],branchinfo[ cl[1] ].leaves[ cl[2] ][2],10,10)
		end
	end
	
	-- additional dropdown for extra controls
	love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3])
	love.graphics.rectangle("fill",0,-70+sliderinfo[2].a,140,100)
	love.graphics.rectangle("fill",4,34,14,14)
	--colouring and switchtoggle
	love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3],255)
	love.graphics.rectangle("line",4,34,14,14)
	if sliderinfo[2].a <= 0 then
		love.graphics.polygon("fill",5,36,10,46,11,46,16,36)
	else
		love.graphics.polygon("fill",5,46,10,36,11,36,16,46)
	end
	--actual dropdown content
	if settings.subsettings.showbranchpos then
		love.graphics.rectangle("fill",40,-66+sliderinfo[2].a,14,14)
	else
		love.graphics.rectangle("line",40,-66+sliderinfo[2].a,14,14)
	end
	
	--shadow of box
	love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3],180)
	love.graphics.rectangle("fill",140,30,10,sliderinfo[2].a)
	
	-- bpm and playing menu
	love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3])
	love.graphics.rectangle("fill",0,0,140,30)
	love.graphics.polygon("fill",140,0,155,0,140,30)
	love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3],255)
	
	love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3],180)
	love.graphics.polygon("fill",155,0,165,0,150,30,140,30)
	
	love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
	love.graphics.rectangle("line",4,2,24,24)
	if playingaudio then
		if tick > 1 then
			love.graphics.polygon("fill",8,6,24,14,8,22)
		end
	else
		love.graphics.polygon("fill",8,6,24,14,8,22)
	end
	love.graphics.print(sounds.info.bpm,55,8)
	love.graphics.print("BPM",120,8)
	love.graphics.setFont(font24)
	love.graphics.print("< <    > >",28,5)
	
	if currenttable == toolsradialtable then
		love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3],255)
		love.graphics.rectangle("fill",(screenWidth/2)-110,(screenHeight/2)-110,220,220)
		love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3],255)
		love.graphics.rectangle("fill",(screenWidth/2)-100,(screenHeight/2)-100,200,200)
		love.graphics.setColor(settings.colour[2][1],settings.colour[2][2],settings.colour[2][3],255)
		
		love.graphics.rectangle("line",(screenWidth/2)-95,(screenHeight/2)-95,125,60)
		love.graphics.rectangle("line",(screenWidth/2)+35,(screenHeight/2)-95,60,125)
		love.graphics.rectangle("line",(screenWidth/2)-95,(screenHeight/2)-30,60,125)
		love.graphics.rectangle("line",(screenWidth/2)-30,(screenHeight/2)-30,60,60)
		love.graphics.rectangle("line",(screenWidth/2)-30,(screenHeight/2)+35,125,60)
		love.graphics.print("B",(screenWidth/2)-38,(screenHeight/2)-70)
		love.graphics.print("L",(screenWidth/2)+60,(screenHeight/2)-38)
		love.graphics.print("+1",(screenWidth/2)-10,(screenHeight/2)-6)
		love.graphics.print("P",(screenWidth/2)-70,(screenHeight/2)+25)
		love.graphics.print("V",(screenWidth/2)+28,(screenHeight/2)+60)
		
	end
end