love.graphics.setMode(400,600)

--26 april 2012 == 2262 lines
--10 may 2012 == 2499 lines

--function that will refresh data, other end in controls at the debug on input.
function nload()
	ropeRead("/projects/AudioTree/ow_sip.lua")
	ropeRead("/projects/AudioTree/moan.lua")
	ropeRead("/projects/AudioTree/ow_rope.lua")
	ropeRead("/projects/AudioTree/ow_awol.lua")
	ropeRead("/projects/AudioTree/engine.lua")
	ropeRead("/projects/AudioTree/gamestate.lua")
	ropeRead("/projects/AudioTree/colourpresets.lua")
	ropeRead("/projects/AudioTree/graphics.lua")
	ropeRead("/projects/AudioTree/illusion.lua")
	ropeRead("/projects/AudioTree/camera.lua")
	ropeRead("/projects/AudioTree/control.lua")
	ropeRead("/projects/AudioTree/particles.lua")
	
	lastmod = {
		{"/projects/AudioTree/ow_sip.lua","/projects/AudioTree/moan.lua","/projects/AudioTree/ow_rope.lua","/projects/AudioTree/ow_awol.lua","/projects/AudioTree/engine.lua","/projects/AudioTree/gamestate.lua","/projects/AudioTree/colourpresets.lua","/projects/AudioTree/graphics.lua","/projects/AudioTree/illusion.lua","/projects/AudioTree/camera.lua","/projects/AudioTree/control.lua","/projects/AudioTree/particles.lua"},
		{},
	}
	for i,v in ipairs(lastmod[1]) do
		local temp,_ = love.filesystem.getLastModified(v)
		table.insert(lastmod[2],temp)
		temp,_ = nil,nil
	end
end


version = 0.45

resolutions = love.graphics.getModes()
table.sort(resolutions, function(a, b) return a.width*a.height < b.width*b.height end)
tooltip = null
debug = false
load = false
typedinput = false
playingaudio = false
typed = {}
sliderinfo = {{name="sidemenu",a=0,b=0,speed=350},{name="submenu",a=0,b=0,speed=350},}
branches = {}
branchinfo = {}
sounds = {
info = {canvasx=0,current=0,bpm=96,pos=1,activebranches={}},
data = {},
}
synth = {}
-- temporary branch coordinates
tempbran = {}
tools = {"branch","leaf","pitch","volume"}
toolsicon = {"B","L","P","V"}
tool = "branch"
toolicon = "B"
-- nearestbranchend (closestlineend)
cle = 0
-- nearestleafend (closestleaf)
cl = {0,0}
-- tick measurer
tick = 0
-- menu width	
menuwidth = 200
menushow = true

area = "pre-menu"

screenWidth = love.graphics.getWidth()
screenHeight = love.graphics.getHeight()

obscurelogo = love.graphics.newImage("/projects/AudioTree/obscurelogo.png")
obscurelogo:setFilter("nearest","nearest")
lovelogo = love.graphics.newImage("/projects/AudioTree/lovelogo.png")
lovelogo:setFilter("linear","linear")

font14 = love.graphics.newFont( "Lekton-Bold.ttf",12)
font24 = love.graphics.newFont( "Lekton-Bold.ttf",18)
font48 = love.graphics.newFont( "Lekton-Bold.ttf",48)
font94 = love.graphics.newFont( "Lekton-Bold.ttf",94)
debugfont = love.graphics.newFont( "Lekton-Bold.ttf",12)
	
love.graphics.setLineStyle("smooth")
	
love.filesystem.load("/projects/AudioTree/ow_rope.lua")()
nload()
currenttable = pretable
	
effectsinfo = {}
ropeRead("/projects/AudioTree/effects/audioeffects.lua")

addeffects()
ropeLoad("ATree","settings.lua")

if not settings.premenu then
	--first loading
	area = "load"
	load = true
	currenttable = loadtable
	love.graphics.setMode( settings.currentres[1], settings.currentres[2], settings.fullscreen)
	love.filesystem.write("settings.lua","settings="..ropeBurn(settings))
	screenWidth, screenHeight = settings.currentres[1],settings.currentres[2]
	love.audio.setVolume( settings.volume )
	if settings.canvases then
		sounds.info.canvas = love.graphics.newCanvas(screenWidth,30)
		treecontrolrender()
	end
	area = "menu"
	currenttable = menutable
	currenttable[1].w,currenttable[1].h = screenWidth, screenHeight
	load = false
end

function updater(dt)
	if tick <= 2 then
		tick = tick + (2*dt)
	elseif tick > 2 then
		tick = 0
	end
	keydown()

	variableupdate(dt)
	slider(dt)
	synth.audiomanager(dt)
end

function graphics()
	love.graphics.scale(Z[1])
	love.graphics.translate(math.floor(-camera.x), math.floor(-camera.y))
	love.graphics.setColor(settings.colour[1][1],settings.colour[1][2],settings.colour[1][3])
	love.graphics.rectangle("fill",0,0,screenWidth,screenHeight)
	love.graphics.setColor(255,255,255)
	
	display()
	
	if debug then
		if currenttable ~= null then
			love.graphics.setColor(200,200,200,100)
			for i = 2,#currenttable do
				love.graphics.rectangle("fill",currenttable[i].x,currenttable[i].y,currenttable[i].w,currenttable[i].h)
			end
			love.graphics.setColor(255,255,255,255)
		end
	
		love.graphics.setFont(debugfont)
		love.graphics.setColor(0,0,0,100)
		love.graphics.rectangle("fill",mX+5,mY+5,150,50)
		love.graphics.setColor(255,255,255,255)
		love.graphics.print("Mpos="..love.mouse.getX().." : "..love.mouse.getY(),mX+10,mY+5)
		love.graphics.print("fps="..love.timer.getFPS(),mX+10,mY+17)
		love.graphics.print("screensize="..screenWidth.." : "..screenHeight,mX+10,mY+29)
		local temp = {templo()}
		love.graphics.print(temp[1]..":"..temp[2],mX+10,mY+41)
	elseif not debug and tooltip ~= null then
		local x,y = mX,mY
		if mX + 160 > screenWidth then
			x = mX-165
		end
		if mY + (20+(14*(font14:getWidth(tooltip)/150))) > screenHeight then
			y = mY - (20+(14*(font14:getWidth(tooltip)/150)))
		end
		love.graphics.setFont(font14)
		love.graphics.setColor(0,0,0,100)
		love.graphics.rectangle("fill",x+5,y+5,160,20+(14*(font14:getWidth(tooltip)/150)))
		love.graphics.setColor(255,255,255,255)
		love.graphics.printf(tooltip,x+10,y+10,150,"left")
		love.graphics.setFont(font24)
	elseif not debug and sip.info.power then
		sip.display()
	end
end