love.graphics.setMode(1024,768)

nully = {
	{x=0,y=0,w=1024,h=768,action={"null"}}
}

es = {
	galaxy = love.graphics.newImage("projects/Effects Showcase/galaxy.png"),
	sun = love.graphics.newImage("projects/Effects Showcase/sun.png"),
	logo = love.graphics.newImage("projects/Effects Showcase/obscure.png"),
	r = 0,
	lineNb = 512,
	time = 0,
	canvass = love.graphics.newCanvas(1024,768),

	effect = love.graphics.newPixelEffect [[
	extern vec2 chroma;
	vec4 effect(vec4 color, Image tex, vec2 tc, vec2 pc)
	{
	   vec2 shift = chroma / 512.0;
	   return vec4(Texel(tex, tc+shift).r, Texel(tex,tc).g, Texel(tex,tc-shift).b, 1.0);
	}
	]],
	effect2 = love.graphics.newPixelEffect[[
	extern number time;

	// noise effect intensity value (0 = no effect, 1 = full effect)
	extern number nIntensity;

	// scanlines effect intensity value (0 = no effect, 1 = full effect)
	extern number sIntensity;

	// scanlines effect count value (0 = no effect, 4096 = full effect)
	extern number sCount;

	vec4 effect(vec4 color, Image tex, vec2 tc, vec2 pc)
	{
	vec4 cTextureScreen = Texel( tex, tc);
	
	number x = tc.x * tc.y * time * 1000.0;
	x = mod( x, 13.0 ) * mod( x, 123.0 );
	number dx = mod( x, 0.01 );
	
	vec3 cResult = cTextureScreen.rgb + cTextureScreen.rgb * clamp( 0.1 + dx * 100.0, 0.0, 1.0 );
	
	vec2 sc = vec2( sin( tc.y * sCount ), cos( tc.y * sCount ) );
	
	cResult += cTextureScreen.rgb * vec3( sc.x, sc.y, sc.x ) * sIntensity;
	
	cResult = cTextureScreen.rgb + clamp( nIntensity, 0.0,1.0 ) * ( cResult - cTextureScreen.rgb );
	
	//cResult = vec3( cResult.r * 0.3 + cResult.g * 0.59 + cResult.b * 0.11 ); //grayscale
	return vec4( cResult, cTextureScreen.a );
	
	}
	]],
	t = 0,
	s = 2,
	c = {0,0},
	ce = effect,
}

es.ce = es.effect
currenttable = nully
es.effect:send("chroma", {10, 10})

function updater(dt)
	es.time = es.time+dt
	x = mX
	y = mY
	if es.c[1] ~= x or es.c[2] ~= y then
		if es.s < 5 then
			es.s = es.s + 0.5
		end
	else
		if es.s > 0 then
			es.s = es.s - 0.05
		end
	end
	es.c = {x,y}
	es.t = es.t + dt*math.random(2)
	local nIntensity = es.s/10
	local sIntensity = es.s/10
	es.effect:send("chroma", { math.sin(es.t+math.random(2)) * es.s, math.cos(es.t+math.random(2)) * es.s})
	es.effect2:send("time",es.time)
	es.effect2:send("nIntensity", nIntensity)
	es.effect2:send("sIntensity", sIntensity)
	es.effect2:send("sCount", es.lineNb)

	es.dt = dt / 2
	es.r = es.r + 1*dt
	es.canvass:clear()
	love.graphics.setCanvas(es.canvass)
	love.graphics.setColor(10,0,20)
	love.graphics.rectangle("fill",0,0,1024,768)
	love.graphics.setColor(255,255,255)
	love.graphics.draw(es.galaxy,0,0)
	love.graphics.circle("fill",780,220,100,100,25)
	love.graphics.setColor(255,255,255,200)
	love.graphics.draw(es.sun,780,220,es.r-15,1,1,278,249)
	love.graphics.draw(es.sun,780,220,-es.r+5,1,1,278,249)
	love.graphics.setColor(255,255,255,255)
	love.graphics.setCanvas()
end

function graphics()
	love.graphics.setColorMode("modulate")
	love.graphics.setBlendMode("additive")
	love.graphics.setPixelEffect(es.ce)
	love.graphics.draw(es.canvass,0,0)
	love.graphics.setPixelEffect()
	love.graphics.draw(es.logo,850,692,0,2)
	love.graphics.print("f1 to change effect.",5,755)
end

function love.keypressed(key)
	if key == "f1" then
		if es.ce == es.effect then
			es.ce = es.effect2
		else
			es.ce = es.effect
		end
	end
	if key == "escape" then
		info.reset()
	end
end